library my_lib;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

{$R *.RES}

uses sysutils;

const max_buf=100;

type arr=array[1..max_buf] of byte;
     parr=^arr;
     str2=string[2];
     DWORD = Longword;

Function GetChar(a:byte):char;
begin
     case a of
          0..9:  result:=chr(a + ord('0'));
          10..15:result:=chr(a + ord('A') - 10);
          end;
end;

Function Hex(a:byte):str2;
begin
     result:=getchar(a div 16)+getchar(a mod 16)
end;

Function ReadStr:PChar; stdcall;
label scan_loop, end_loop, end_id, not_amd, amd_loop;
var Str:    PArr;
    R:      String[max_buf*2];
    count,x:Integer;
begin
     count:=0;
     getmem(str,max_buf);
     asm
        push eax
        push ebx
        push ecx
        push edx
        push edi
        push esi
        mov edi, dword ptr str
        xor eax, eax
db      0Fh, 0A2h
        mov count, eax
                stosd
                mov eax, ebx
                stosd
                mov eax, ecx
                stosd
                mov eax, edx
                stosd
        mov esi, 1
//   CPUID    
scan_loop:
        cmp esi, count
        jg  end_loop
        mov eax, esi
db      0Fh, 0A2h
                stosd
                mov eax, ebx
                stosd
                mov eax, ecx
                stosd
                mov eax, edx
                stosd
        inc esi
        jmp scan_loop
end_loop:
        inc count
//     -  
        mov esi, dword ptr str
        bt dword ptr [esi+6*4], 17 //cpuid(1).edx.18 
        jnc end_id
        inc count
        mov eax, 3
db      0Fh, 0A2h
                stosd
                mov eax, ebx
                stosd
                mov eax, ecx
                stosd
                mov eax, edx
                stosd
end_id:
//   AMD
        cmp dword ptr [esi+2*4], 444D4163h // 
        jne not_amd
        mov eax, 80000000h
        push eax
db      0Fh, 0A2h
        mov esi ,eax
        pop eax
amd_loop:
        push eax
db      0Fh, 0A2h
        inc count
                stosd
                mov eax, ebx
                stosd
                mov eax, ecx
                stosd
                mov eax, edx
                stosd
        pop eax
        inc eax
        cmp eax, esi
        jle amd_loop
not_amd:
        pop esi
        pop edi
        pop edx
        pop ecx
        pop ebx
        pop eax
     end;
     r:='';
     for x:=1 to count*16 do begin
         r:=r+hex(str^[x]);
     end;
     getmem(result,length(r)+1);
     strpcopy(result,r);
end;

exports ReadStr;

begin
end.
